﻿using System;
using SuperMap.Desktop;
using SuperMap.UI;
using System.Data;
using System.Windows.Forms;
using SuperMap.Data;

namespace SuperMap.Desktop.GetPointXY
{
    class _CtrlActionGetPointXY:CtrlAction
    {
        //Use base class constructor with parameters

        public _CtrlActionGetPointXY(IBaseItem caller)
            : base(caller)
        {}

        public override void Run()
        {
            try
            {
                IFormTabular tabularWindow = Application.ActiveApplication.MainForm.FormManager.ActiveForm as IFormTabular;
                if (tabularWindow == null)
                {
                    throw new Exception("Please open an attribute table of a dataset");
                }
                Recordset objRecordset = tabularWindow.TabularControl.Recordset;
                DatasetVector objDatasetVector = (objRecordset.Dataset) as DatasetVector;
                if (objDatasetVector != null)
                {
                    //Get field list from the recordset

                    FieldInfos fieldInfos = objDatasetVector.FieldInfos;
                    //Close the recordset

                    objRecordset.Close();
                    objRecordset.Dispose();
                    //Close the attribute table
                    System.Windows.Forms.Form objForm = tabularWindow as Form;
                    objForm.Close();
                    objForm.Dispose();
                    //if UserX and UserY already exist, then delete them

                    if (fieldInfos["UserX"] != null || fieldInfos["UserY"] != null)
                    {
                        //Delete the two fields

                        fieldInfos.Remove("UserX");
                        fieldInfos.Remove("UserY");
                    }
                    //Create UserX and UserY
                    FieldInfo fieldUserX = new FieldInfo();
                    fieldUserX.Name="UserX";
                    fieldUserX.Caption = "UserX";
                    fieldUserX.Type = FieldType.Double;
                    fieldUserX.MaxLength = 12;

                    FieldInfo fieldUserY = new FieldInfo();
                    fieldUserY.Name = "UserY";
                    fieldUserY.Caption = "UserY";
                    fieldUserY.Type = FieldType.Double;
                    fieldUserY.MaxLength = 12;

                    //Update field information
                    if (fieldInfos.Add(fieldUserX) != -1 && fieldInfos.Add(fieldUserY) != -1)
                    {
                        Application.ActiveApplication.Output.Output("Succeeded to add UserX and UserY");
                        //Get values for UserX and UserY
                        //First get the recordset corresponding to the dataset
                        Recordset newRecordset = objDatasetVector.GetRecordset(false, CursorType.Dynamic);
                        if (newRecordset != null)
                        {
                            //Use the progress bar to keep track of the current record number

                            int nCount = newRecordset.RecordCount;
                            newRecordset.MoveFirst();
                            for (int i = 0; i < nCount; i++)
                            {
                                newRecordset.Edit();
                                newRecordset.SetFieldValue("UserX", newRecordset.GetGeometry().InnerPoint.X);
                                newRecordset.SetFieldValue("UserY", newRecordset.GetGeometry().InnerPoint.Y);
                                newRecordset.Update();
                                newRecordset.MoveNext();
                            }
                            newRecordset.Close();
                            newRecordset.Dispose();
                            Application.ActiveApplication.Output.Output("Succeeded to add interior point coordinates to the attribute table!");
                        }
                        else
                        {
                            throw new Exception("Failed to get recordet");
                        }

                    }
                    else
                    {
                        throw new Exception("Failed to add UserX and UserY");
                    }
                }
                else
                {
                    throw new Exception("Failed to get recordet corresponding to the dataset");
                }
            }
            catch (Exception ex)
            {
                Application.ActiveApplication.Output.Output(ex.Message);
                return;
            }
        }
        }
    }

